// Funge JIT compiler
// Copyright (c) 2004 Marek Materzok
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or 
// (at your option) any later version.

#ifndef __Bflib_hpp
#define __Bflib_hpp

#include <ostream>

#include <llvm/Module.h>
#include <llvm/Type.h>
#include <llvm/DerivedTypes.h>
#include <llvm/Instructions.h>

#include "bflib.h"

namespace bflib
{
	extern llvm::Function *main,
		*init,
		*begin_block,
		*end_block,
		*stack_transfer,
		*push_int,
		*pop_int,
		*push_int_many,
		*push_vector,
		*pop_vector,
		*input_int,
		*output_int,
		*input_char,
		*output_char,
		*fetch_char,
		*store_char,
		*fungespace_get,
		*fungespace_put,
		*go_away,
		*clear_stack;
	extern const llvm::Type *vector;
	extern llvm::GlobalVariable *thread;
};

llvm::Module *load_bflib();

inline std::ostream &
operator<<(std::ostream &s, const Vector &v)
{
	s << "[" << v.v[0] << "," << v.v[1] << "," << v.v[2] << "]";
	return s;
}

llvm::Value *get_thread_vector_value(int x1, int x2, llvm::BasicBlock *cb);


#endif
