// Funge JIT compiler
// Copyright (c) 2004 Marek Materzok
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or 
// (at your option) any later version.

#ifndef __bflibsimplifystackpass_hpp
#define __bflibsimplifystackpass_hpp

#include <vector>

#include <llvm/Pass.h>

class BflibSimplifyStackPass: public llvm::BasicBlockPass
{
	public:
		virtual bool doInitialization(llvm::Module &m);
		virtual bool runOnBasicBlock(llvm::BasicBlock &m);
		virtual bool doFinalization(llvm::Module &m);

		virtual void getAnalysisUsage(llvm::AnalysisUsage &info) const;

	private:
		void addPushMany(std::vector<llvm::CallInst*> &list, llvm::Instruction *ins);
};

#endif

